//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

extern int    MagicNumber = 123456;
extern bool   EcnBroker   = false;
extern double LotSize     = 0.1;
extern int    Slippage    = 3;
extern double StopLoss    = 100;
extern double TakeProfit  = 100;
extern int    BarToUse    = 1;

extern int                Ma1Period   = 12;
extern ENUM_APPLIED_PRICE Ma1Price    = PRICE_CLOSE;
extern ENUM_MA_METHOD     Ma1Method   = MODE_SMA;
extern int                Ma2Period   = 26;
extern ENUM_APPLIED_PRICE Ma2Price   = PRICE_CLOSE;
extern ENUM_MA_METHOD     Ma2Method   = MODE_SMA;

bool dummyResult;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   { return(0); }
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing 0
#define _doBuy     1
#define _doSell    2
int start()
{
   int doWhat = _doNothing;
      double diffc = iMA(NULL,0,Ma1Period,0,Ma1Method,Ma1Price,BarToUse)  -iMA(NULL,0,Ma2Period,0,Ma2Method,Ma2Price,BarToUse);
      double diffp = iMA(NULL,0,Ma1Period,0,Ma1Method,Ma1Price,BarToUse+1)-iMA(NULL,0,Ma2Period,0,Ma2Method,Ma2Price,BarToUse+1);
      if ((diffc*diffp)<0)
         if (diffc>0)
               doWhat = _doBuy;
         else  doWhat = _doSell;
         if (doWhat==_doNothing) return(0);
         
   //
   //
   //
   //
   //
   
   int openedBuys  = 0;
   int openedSells = 0;
   for (int i = OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()      != Symbol())            continue;
      if (OrderMagicNumber() != MagicNumber)         continue;
      if (OrderType()==OP_BUY && doWhat==_doSell)
            dummyResult = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,CLR_NONE);
      else  openedBuys++;
      if (OrderType()==OP_SELL && doWhat==_doBuy)
            dummyResult = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,CLR_NONE);
      else  openedSells++;            
   }
   
   //
   //
   //
   //
   //

   if (doWhat==_doBuy && openedBuys==0)
      {
         double stopLossBuy   = 0; if (StopLoss>0)   stopLossBuy   = Ask-StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitBuy = 0; if (TakeProfit>0) takeProfitBuy = Ask+TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int ticketb = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,0,0,"",MagicNumber,0,CLR_NONE);
            if (ticketb>-1)
               dummyResult = OrderModify(ticketb,OrderOpenPrice(),stopLossBuy,takeProfitBuy,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_BUY,LotSize,Ask,Slippage,stopLossBuy,takeProfitBuy,"",MagicNumber,0,CLR_NONE);
      }
   if (doWhat==_doSell && openedSells==0)
      {
         double stopLossSell   = 0; if (StopLoss>0)   stopLossSell   = Bid+StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitSell = 0; if (TakeProfit>0) takeProfitSell = Bid-TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int tickets = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,0,0,"",MagicNumber,0,CLR_NONE);
            if (tickets>-1)
               dummyResult = OrderModify(tickets,OrderOpenPrice(),stopLossSell,takeProfitSell,0,CLR_NONE);
         }
         else dummyResult = OrderSend(Symbol(),OP_SELL,LotSize,Bid,Slippage,stopLossSell,takeProfitSell,"",MagicNumber,0,CLR_NONE);
      }
   return(0);
}